//=============================================================================
//
//   Co-Rotational Finite Element Method source code
//   Based on Physics-Based Animation book, chapter 10
//
//   Based on original implementation by
//							Miguel A. Otaduy,    URJC Madrid
//							Alvaro G. Perez,     URJC Madrid
//							and Javier S. Zurdo, URJC Madrid
//
//	Authors:
//			Krisztian Amit Birkas, McGill Uni.
//			Jesus Perez Rodriguez, IST Austria
//
//=============================================================================

#pragma once
#include <string>
#include <vector>
#include <FEM.h>

//////////////////////////////////////////////////////////////////////////////
// TetGenReader
//
// Description:
//		Static class for reading files generated by TetGen into FEM.h 
//		User needs provide only filenames and reference to FEM.
//		Filename must be only the main name (no extensions)
//		e.g.:
//		cylinder_chamber.1.ele, .1.face, .1.node -> cylinder_chamber
//		
//		Note: there are a lot of places to optimize, but this is a preprocessing step, so I tried to make it more clear, than optimal.
//////////////////////////////////////////////////////////////////////////////

struct TetGenNode; // structs for TetGenReader, that are used to store, combine, and normalize data before passing them to FEM
struct TetGenFace; // structs for TetGenReader, that are used to store, combine, and normalize data before passing them to FEM
struct TetGenTetrahedron; // structs for TetGenReader, that are used to store, combine, and normalize data before passing them to FEM
struct TetGenEdge; // structs for TetGenReader, that are used to store, combine, and normalize data before passing them to FEM

static class TetGenReader
{
public:
	static void readTetgenObject(std::string filename, FEM* &fem, std::vector<Tetrahedron*> &tets);
	static void readAndCombineTetGenObjects(std::string filename1, std::string filename2, FEM* &fem, std::vector<Tetrahedron*> &tets);
	static void readPoly(std::string filename1, FEM* &fem, std::vector<Tetrahedron*> &fem_tets);

private:
	// Readers
	static std::vector<TetGenNode> readNodes(std::string fileName);
	static std::vector<TetGenFace> readFaces(std::string fileName);
	static void readFacesPoly(std::string fileName, std::vector<TetGenFace>& faces, std::vector<TetGenFace>& chamberFaces, std::vector<TetGenFace>& notChamberFaces);
	static std::vector<TetGenTetrahedron> readTetrahedrons(std::string fileName);
	static std::vector<TetGenEdge> readEdges(std::string fileName);
	static void readFileLinesInto(std::string fileName, std::vector<std::string> &lines);

	// Normalize data
	static std::vector<int> matchNodesUsingConvexHull(std::vector<TetGenNode> n1, std::vector<TetGenNode> n2);
	static std::vector<int> matchNodes(std::vector<TetGenNode> n1, std::vector<TetGenNode> n2);
	static void rearrangeIndices(std::vector<TetGenNode> &n, std::vector<TetGenFace> &f, std::vector<TetGenTetrahedron> &t, std::vector<TetGenEdge> &e, std::vector<TetGenFace> &cf);
	static void addToFEM(const std::vector<TetGenNode> &n, const std::vector<TetGenFace> &f, const std::vector<TetGenTetrahedron> &t, const std::vector<TetGenEdge> &e, const std::vector<TetGenFace> &cf, const std::vector<TetGenFace> &ncf, FEM* &fem, std::vector<Tetrahedron*> &tets);
	static std::vector<TetGenNode> mergeNodes(std::vector<TetGenNode> &nodesExternal, std::vector<TetGenNode> &nodesChamber, std::vector<TetGenFace> &facesChamber, std::vector<TetGenTetrahedron> &tetsChamber, std::vector<TetGenEdge> &edgesChamber);
	static void convertIndexingToStartFrom0(std::vector<TetGenNode> &n, std::vector<TetGenFace> &f, std::vector<TetGenTetrahedron> &t, std::vector<TetGenEdge> &e);
	static void convertIndexingToStartFrom0(std::vector<TetGenNode> &n, std::vector<TetGenFace> &f, std::vector<TetGenFace> &f2, std::vector<TetGenFace> &f3, std::vector<TetGenTetrahedron> &t, std::vector<TetGenEdge> &e);
	static void fixNormal(TetGenFace &face, bool outward, const std::vector<TetGenNode> &nodes, Eigen::Vector3d centerOfMass);

	// Data correctness check
	static bool isNodeMappingCorrect(std::vector<std::pair<int, int>> pairs);
};

